package com.example.union_ad_ssgf


import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.EventChannel;
import io.flutter.plugin.common.MethodChannel;

/**
 * 三商共富 - 三方插件
 */
class UnionAdSsgfPlugin : FlutterPlugin, ActivityAware {
    /**
     * 方法通道：
     *
     * 用于Flutter与原生Android之间通信的 MethodChannel
     * 此本地引用用于向Flutter引擎注册插件，并在Flutter引擎与Activity分离时注销它
     */
    private lateinit var methodChannel: MethodChannel

    /**
     * 事件通道
     *
     * 用于Flutter与原生Android之间通信的 EventChannel
     * 此本地引用用于向Flutter引擎注册插件，并在Flutter引擎与Activity分离时注销它
     */
    private lateinit var eventChannel: EventChannel


    /**
     * 插件代理
     */
     var delegate: PluginDelegate? = null


    /**
     * 插件连接器
     */
    private lateinit var bind: FlutterPlugin.FlutterPluginBinding

    /**
     *  初始化方法通道和事件通道
     */
    override fun onAttachedToEngine(flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        bind = flutterPluginBinding

        // 注册 - 方法通道
        methodChannel = MethodChannel(flutterPluginBinding.binaryMessenger, "union_ad_ssgf_method")

        // 注册 - 监听通道
        eventChannel = EventChannel(flutterPluginBinding.getBinaryMessenger(), "union_ad_ssgf_event")
    }

    /**
     * 注销通道
     */
    override fun onDetachedFromEngine(p0: FlutterPlugin.FlutterPluginBinding) {
        // 解除 - 方法通道
        methodChannel.setMethodCallHandler(null)

        // 解除 - 事件通道
        eventChannel.setStreamHandler(null)
    }

    /**
     * 绑定activity
     */
    override fun onAttachedToActivity(binding: ActivityPluginBinding) {
        delegate = PluginDelegate(binding.activity, bind)
        methodChannel.setMethodCallHandler(delegate)
        eventChannel.setStreamHandler(delegate)
    }


    override fun onDetachedFromActivityForConfigChanges() {
        onDetachedFromActivity()
    }

    override fun onReattachedToActivityForConfigChanges(binding: ActivityPluginBinding) {
        onAttachedToActivity(binding)
    }

    override fun onDetachedFromActivity() {
        this.delegate = null
    }
}
