package com.example.union_ad_ssgf.page

import android.content.Context
import android.view.View
import android.widget.FrameLayout
import com.qq.e.ads.banner2.UnifiedBannerADListener
import com.qq.e.ads.banner2.UnifiedBannerView
import com.qq.e.comm.util.AdError
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.platform.PlatformView
import java.util.Locale

import android.util.Log;
import com.example.union_ad_ssgf.PluginDelegate
import com.example.union_ad_ssgf.event.AdEventAction

class AdBannerView(
    context: Context,
    private var id: Int,
    creationParams: Map<String, Any>?,
    private var pluginDelegate: PluginDelegate?
) : BaseAdPage(), PlatformView, UnifiedBannerADListener {
    private val TAG = AdBannerView::class.java.getSimpleName()
    private var frameLayout = FrameLayout(context)
    private var bv: UnifiedBannerView? = null
    private var params = creationParams

    init {
        val call = MethodCall("AdBannerView", creationParams)
        showAd(this.pluginDelegate!!.activity, id, call);
    }

    override fun loadAd(call: MethodCall?) {
        // 获取轮播时间间隔参数
        val interval = params!!["interval"] as Int
        // 加载广告 Banner
        bv = UnifiedBannerView(activity, posId, this)
        frameLayout!!.addView(bv)
        // 设置轮播时间间隔
        bv!!.setRefresh(interval)
        bv!!.loadAD()
    }

    override fun getView(): View? {
        return frameLayout;
    }

    override fun dispose() {
        disposeAd();
    }

    override fun onNoAD(error: AdError) {
        val msg = java.lang.String.format(
            Locale.getDefault(), "onNoAD, error code: %d, error msg: %s",
            error.getErrorCode(), error.getErrorMsg()
        )
        Log.e(TAG, msg)
        sendErrorEvent(error.getErrorCode(), error.getErrorMsg())
        disposeAd()
    }

    override fun onADReceive() {
        Log.i(TAG, "onADReceive");
        sendEvent(AdEventAction.onAdLoaded);
    }

    override fun onADExposure() {
        Log.i(TAG, "onADExposure");
        sendEvent(AdEventAction.onAdExposure);
    }

    override fun onADClosed() {
        Log.i(TAG, "onADClosed");
        sendEvent(AdEventAction.onAdClosed);
        disposeAd();
    }

    override fun onADClicked() {
        Log.i(TAG, "onADClicked");
        sendEvent(AdEventAction.onAdClicked);
    }

    override fun onADLeftApplication() {
        Log.i(TAG, "onADLeftApplication");
    }

    /**
     * 销毁广告
     */
    private fun disposeAd() {
        frameLayout!!.removeAllViews()
        if (bv != null) {
            bv!!.destroy()
        }
    }

}