package com.example.union_ad_ssgf.page

import android.app.Activity
import com.example.union_ad_ssgf.config.UnionADConfig
import com.example.union_ad_ssgf.event.AdErrorEvent
import com.example.union_ad_ssgf.event.AdEvent
import com.example.union_ad_ssgf.event.AdEventHandler
import io.flutter.plugin.common.MethodCall

abstract class BaseAdPage {
    // 上下文
    protected var activity: Activity? = null

    // 广告位 id
    protected var posId: String? = null

    // 广告位 id
    protected var adId: String? = null

    // 广告定位ID
    protected var viewId: Int? = null

    /**
     * 显示广告
     *
     * @param activity 上下文
     * @param call 方法调用
     */
    fun showAd(activity: Activity?, viewId: Int?, call: MethodCall) {
        this.activity = activity
        this.viewId = viewId
        this.posId = call.argument<String>(UnionADConfig.KEY_POSID)
        this.adId = call.argument<String>(UnionADConfig.KEY_ADID)
        loadAd(call)
    }

    /**
     * 加载广告
     * @param call 方法调用
     */
    abstract fun loadAd(call: MethodCall?)

    /**
     * 发送广告事件
     * @param event 广告事件
     */
    protected fun sendEvent(event: AdEvent?) {
        AdEventHandler.getInstance()?.sendEvent(event)
    }

    /**
     * 发送广告事件
     *
     * @param action 操作
     */
    protected fun sendEvent(action: String?) {
        sendEvent(AdEvent(posId, adId, viewId, action))
    }

    /**
     * 发送错误事件
     *
     * @param errCode 错误码
     * @param errMsg 错误事件
     */
    protected fun sendErrorEvent(errCode: Int, errMsg: String?) {
        sendEvent(AdErrorEvent(posId, adId, viewId, errCode, errMsg))
    }
}
