package com.example.union_ad_ssgf.page

import android.content.Context
import com.example.union_ad_ssgf.PluginDelegate
import com.example.union_ad_ssgf.config.UnionADConfig
import io.flutter.plugin.common.StandardMessageCodec
import io.flutter.plugin.platform.PlatformView
import io.flutter.plugin.platform.PlatformViewFactory

/// View 名字
class NativeViewFactory(
    private val viewName: String, // 插件代理类
    private val pluginDelegate: PluginDelegate
) :
    PlatformViewFactory(StandardMessageCodec.INSTANCE) {

    override fun create(context: Context, viewId: Int, args: Any?): PlatformView {
        val creationParams = args as Map<String, Object>
        return if (viewName == UnionADConfig.KEY_BANNER_VIEW) {
            AdBannerView(context, viewId, creationParams, pluginDelegate)
        } else {
            AdFeedView(context, viewId, creationParams, pluginDelegate)
        }
    }

}