import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'union_ad_ssgf_method_channel.dart';

abstract class UnionAdSsgfPlatform extends PlatformInterface {
  /// Constructs a UnionAdSsgfPlatform.
  UnionAdSsgfPlatform() : super(token: _token);

  static final Object _token = Object();

  static UnionAdSsgfPlatform _instance = MethodChannelUnionAdSsgf();

  /// The default instance of [UnionAdSsgfPlatform] to use.
  ///
  /// Defaults to [MethodChannelUnionAdSsgf].
  static UnionAdSsgfPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [UnionAdSsgfPlatform] when
  /// they register themselves.
  static set instance(UnionAdSsgfPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }
}
